/*
 * Der einarmige Bandit
 * Anfangkapital: 300 Euro
 * Sind alle drei Zahlen gleich, wird das Vierfache,
 * sind zwei Zahlen gleich, so das Doppelte
 * des Einsatzes zurckgezahlt,
 * sonst wird der Einsatz vom Kapital abgezogen.
 * Das Spiel endet, falls das Kapital aufgebraucht
 * wurde bzw. falls es 500 Euro ueberschreitet.
 */

# include <stdio.h>                 /* printf, scanf */
# include <stdlib.h>                  /* srand, rand */
# include <time.h>                           /* time */

int main()
{
  unsigned int kapital, einsatz;
  unsigned int zahl1, zahl2, zahl3, n;
  unsigned int runden = 0;

/* Ueberschrift */
  printf( "Der einarmige Bandit\n\n");

/* Setze Startkapital */
  kapital = 300;

/* Zufallsgenerator */
  srand(time( NULL));

  while( kapital > 0 && kapital < 500)
  {
/* Spielrunden */
    runden++;
    printf( "Runde: %u. ", runden);
    printf( "Du hast ein Kapital von %u Euro!\n",
             kapital);
    do                            /* Eingabe Einsatz */
    {
      printf( "Dein Einsatz: ");
      scanf( "%u", &einsatz);
    } while( kapital < einsatz || einsatz <= 0);

    kapital -= einsatz;

/*  printf( "Kapital: %u\n", kapital);  Testausdruck */
/*  printf( "Einsatz: %u\n", einsatz);  Testausdruck */

    zahl1 = rand() % 9 + 1;   /* Wuerfeln der Zahlen */
    zahl2 = rand() % 9 + 1;
    zahl3 = rand() % 9 + 1;

    printf( "%u  %u  %u\n", zahl1, zahl2, zahl3);

    n = 1;                         /* Ausgabe Gewinn */
    if( zahl1 == zahl2) n++;
    if( zahl1 == zahl3) n++;
    if( zahl2 == zahl3) n++;

/*  printf( "n = %u\n", n);             Testausdruck */

    if( n != 1) kapital += n * einsatz;

/*  printf( "Kapital: %u\n", kapital);  Testausdruck */
  }

/* Spielauswertung*/
  if( kapital <= 0)
    printf( "%u Runden und Du bist Pleite!\n", runden);
  else
  {
    printf( "%u Runden und der Bandit ist Pleite!\n",
             runden);
    printf( "Du hast ein Kapital von %u Euro!\n",
             kapital);
  }

  return 0;
}
