/*
 * MasterMind: 4 Zahlen aus 1..6 sind zu erraten.
 * Auswertung jedes Rateversuchs:
 * weiss - richtige Zahl an richtiger Position
 * schwarz - richtige Zahl an falscher Position
 */

# include <stdio.h>                 /* printf, scanf */
# include <stdlib.h>                  /* srand, rand */
# include <time.h>                           /* time */

/* Zahlenbereich 1 .. MAX */
# define MAX 6
/* Anzahl der Zahlen */
# define LAENGE 4

/*
 * Erzeugt zufaellig Zahlen.
 * Parameter: Zahlenfeld
 *            Feldlaenge
 *            Maximalzahl: 1 .. MAX
 */
void erzeugeZahlen( int *, int, int);

/*
 * Gibt Zahlfeld aus.
 * Parameter: Zahlenfeld
 *            Feldlaenge
 */
void ausgabeZahlen( int *, int);

/*
 * Liest Zahlfeld ein.
 * Parameter: Zahlenfeld
 *            Feldlaenge
 */
void eingabeZahlen( int *, int);

/*
 * Vergleicht zwei Zahlfelder, Wertet Rateversuch aus.
 * Parameter: Zahlenfelder
 *            Feldlaenge
 * Return:    1 ... bei Gleichheit
 *            0 ... sonst
 */
int vergleich( int *, int *, int);

/* --------------------------------------------------------------- */

/*
 * Hauptprogramm: Spieldialog.
 */
int main()
{
  int geheim[ LAENGE], geraten[ LAENGE];
  int fertig = 0, runden = 0;

/* Ueberschrift */
  printf( "MasterMind\n\n");

/* Erzeugen der Geheimzahlen */
  erzeugeZahlen( geheim, LAENGE, MAX);
/*  ausgabeZahlen( geheim, LAENGE);     Testausdruck */

/* Spielrunden */
  do
  {
    runden++;
                           /* Eingabe der Ratezahlen */
    printf( "Rate:\t");
    eingabeZahlen( geraten, LAENGE);
/*    ausgabeZahlen( geraten, LAENGE);  Testausdruck */

                     /* Auswertung des Rateversuches */
    fertig = vergleich( geheim, geraten, LAENGE);

  } while( !fertig);


/* Abschlussauswertung */
  printf( "Runden: %d\n", runden);
  printf( "Geheimzahlen:\n\t");
  ausgabeZahlen( geheim, LAENGE);

  return 0;
}

/* --------------------------------------------------------------- */

/*
 * Erzeugt zufaellig Zahlen.
 */
void erzeugeZahlen( int *zahlen, int n, int max)
{
  int i;

/* Zufallsgenerator */
  srand( time( NULL));

  for( i = 0; i < n; i++) 
    zahlen[ i] = rand() % max + 1;

  return;
}


/*
 * Gibt Zahlfeld aus.
 */
void ausgabeZahlen( int *zahlen, int n)
{
  int i;

  for( i = 0; i < n; i++)
    printf( "%d", zahlen[ i]);
  printf( "\n");

  return;
}


/*
 * Liest Zahlfeld ein.
 */
void eingabeZahlen( int *zahlen, int n)
{
  int i;

  for( i = 0; i < n; i++)
  {
    scanf( "%1d", &zahlen[ i]);
  }

  return;
}


/*
 * Vergleicht zwei Zahlfelder, Wertet Rateversuch aus.
 */
int vergleich( int *zahlen1, int *zahlen2, int n)
{
  int i, j, weiss = 0, schwarz = 0;

  printf( "*\n");

/* richtige Zahl an richtiger Position */
  for( i = 0; i < n; i++)
    if( zahlen1[ i] == zahlen2[ i])
    {
      weiss++;
    }

/* Fertig */
  if ( weiss == n) return 1;

/* richtige Zahl an beliebiger Position */
  for( i = 0; i < n; i++)
  {
    for( j = 0; j < n; j++)
    {
      if( zahlen1[ i] == zahlen2[ j])
      {
        schwarz++; zahlen2[ j] = 0; break;
      }
    }
  }

/* Sonst */
  printf( "weiss   %d: ", weiss);
  printf( "schwarz %d:\n", schwarz - weiss);

  return 0;
}

