/*
 * lotte.c: Lottoziehung 6 aus 49,
 * Ziehungsautomat gibt beliebig viele Lottotipps aus.
 */

# include <stdio.h>                        /* printf */
# include <stdlib.h>                  /* srand, rand */
# include <time.h>                           /* time */

/* Anzahl der Zahlen */
# define ANZAHL 6

/**
 * Zahlen werden geordnet.
 * Parameter: Zahlenfeld
 */
  void ordnen( int *);

/**
 * Zahlen werden gezogen.
 * Parameter: Zahlenfeld
 */
  void ziehen( int *);

/**
 * Ziehungsergebnis.
 * Parameter: Zahlenfeld
 */
  void zeigen( int *);


/**
 * Haiptprogramm: Ziehung starten.
 */
int main()
{
  int zahlen[ ANZAHL];
  char jn[ 2];

/* Zufallsgenerator */
  srand(time( NULL));

/* Ueberschrift */
    printf( "Lottoziehung 6 aus 49.\n\n");
    printf( "Gibt beliebig viele Lottotipps aus. \n");

  do 
  {
/* Ziehung */
    ziehen( zahlen);
    ordnen( zahlen);
    zeigen( zahlen);

/* Weiter */
    printf( "\tWeiter (j/n)?");
    scanf( "%1s", jn);
  } while( jn[ 0] == 'j');

  return 0;
}

/**
 * Zahlen werden gezogen.
 */
  void ziehen( int *zahlen)
  {
    int doppelt, i, j;
    for( i = 0; i < ANZAHL; i++)
    do
    {
      doppelt = 0;              /* Ziehen einer Zahl */
      zahlen[ i] = rand() % 49 + 1;

       /* Vergleich mit den bereits gezogenen Zahlen */
      for( j = 0; j < i; j++)
        if( zahlen[ j] == zahlen[i]) doppelt = 1;
    } while( doppelt);
  }

/**
 * Zahlen werden geordnet.
 */
  void ordnen( int *zahlen)
  {                                    /* SelectSort */
    int i, j;
    for( i = 0; i < ANZAHL - 1; i++)
    {
      int k = i;
      for( j = i + 1; j < ANZAHL; j++)
        if( zahlen[ k] > zahlen[ j]) k = j;
      if( i != k)
      {
        int temp = zahlen[ i];        /* Vertauschen */
        zahlen[ i] = zahlen[ k];
        zahlen[ k] = temp;
      }
    }
  }

/**
 * Ziehungsergebnis.
 */
  void zeigen( int *zahlen)
  {
    int i;
    for( i = 0; i < ANZAHL; i++)
      printf( "\t%d ", zahlen[ i]);
  }
