/*
 * euklid.c: Funktionsdefinitionen
 *
 * Funktionen zur Berechnen des
 * groesster gemeinsamer Teiler,
 * kleinstes gemeinsames Vielfaches
 * zweier natuerlicher Zahlen.
 */

# include "euklid.h"       /* Funktionsdeklarationen */

/*
 * ggT berechnet den groessten gemeinsamen Teiler
 * zweier natuerlicher Zahlen nach Euklid.
 */
unsigned int ggT( unsigned int a, unsigned int b)
{
  unsigned int c;
  do
  {
    c = a % b;     /* Rest der ganzzahligen Division */
    a = b; b = c;           /* Vertauschen der Werte */
  } while( c != 0);

  return a;
}


/*
 * kgV berechnet das kleinste gemeinsamen Vielfache
 * zweier natuerlicher Zahlen mittels ggT.
 */
unsigned int kgV( unsigned int a, unsigned int b)
{
  return a * b / ggT( a, b);
}

