/*
 * Operationen ueber gemeine Brueche
 * Header fuer bruch.c
 */

#ifndef _BRUCH_H_
#define _BRUCH_H_

struct bruch
{
  int Zaehler;
  int Nenner;
};


/* liest einen Bruch ein */
struct bruch bruchEingabe( void);

/* gibt einen Bruch aus */
void bruchAusgabe( struct bruch);

/* liefert zurck, ob ein Bruch eine gltige Zahl darstellt */
int isvalid( struct bruch);

/* liefert die Darstellung von NaN als Bruch */
struct bruch invalid( void);

/* krzt einen Bruch (Normalisierung) */
struct bruch kuerzen( struct bruch);

/* Rckgabe des ggT zweier natuerlicher Zahlen */
unsigned int ggT( unsigned int, unsigned int);

/* liefert das Vorzeichen einer Ganzzahl */
int signum( int);

/* liefert den Betrag einer Ganzzahl */
int absi( int);

/* liefert den Kehrwert eines Bruchs */
struct bruch inverse( struct bruch);

/* liefert den Bruch mit umgekehrtem Vorzeichen */
struct bruch neg( struct bruch);

/* liefert die Summe zweier Brche */
struct bruch add( struct bruch, struct bruch);

/* liefert die Differenz zweier Brche */
struct bruch sub( struct bruch, struct bruch);

/* liefert das Produkt zweier Brche */
struct bruch mult( struct bruch, struct bruch);

/* liefert den Quotienten zweier Brche */
struct bruch div( struct bruch, struct bruch);

#endif
